#include <jni.h>
#include "complex_math_types.h"
#ifndef _Included_CPNative
#define _Included_CPNative
extern "C" {

  JNIEXPORT void JNICALL Java_JNI_CPNative_init(JNIEnv* env, jclass jc);

  JNIEXPORT void JNICALL Java_JNI_CPNative_CPNinitIDs(JNIEnv* env, jclass jc);
  JNIEXPORT void JNICALL Java_JNI_CPNative_C2JinitIDs(JNIEnv* env, jclass jc);

  JNIEXPORT jint JNICALL Java_JNI_CPNative_Execute(JNIEnv* env, jclass jc, jint pnum,jstring str);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_execute(JNIEnv* env, jclass jc, jstring str);
  
  JNIEXPORT jint JNICALL Java_JNI_CPNative_takeThisPath(JNIEnv* env,jclass jc,jint size,jdoubleArray pts);
  JNIEXPORT void JNICALL Java_JNI_CPNative_msgHook(JNIEnv* env,jclass jc,jint flag);
  JNIEXPORT void JNICALL Java_JNI_CPNative_getRealBox(JNIEnv* env, jclass jc,jint packnum);
  JNIEXPORT jdoubleArray JNICALL Java_JNI_CPNative_getPathToDraw(JNIEnv* env, jclass jc,jint length);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getNodeCount(JNIEnv* env, jclass jc);
  JNIEXPORT long JNICALL Java_JNI_CPNative_getGeometry(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getAlpha(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getGamma(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getFaceCount(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getGenus(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getEuler(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getIntrinsicGeometry(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getFirstFace(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getFirstRedFace(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getNBdryComponents(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getNInteriorComponents(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getNInteriorNodes(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getMaxIDeg(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getMinIDeg(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getMaxBDeg(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getMinBDeg(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getDisplayFlag(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getFacesDisplayFlag(JNIEnv* env, jclass jc);
  JNIEXPORT jdouble JNICALL Java_JNI_CPNative_getXMin(JNIEnv* env, jclass jc);
  JNIEXPORT jdouble JNICALL Java_JNI_CPNative_getYMin(JNIEnv* env, jclass jc);
  JNIEXPORT jdouble JNICALL Java_JNI_CPNative_getXMax(JNIEnv* env, jclass jc);
  JNIEXPORT jdouble JNICALL Java_JNI_CPNative_getYMax(JNIEnv* env, jclass jc);
  JNIEXPORT jdouble JNICALL Java_JNI_CPNative_getArea(JNIEnv* env, jclass jc);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getBdryLength(JNIEnv* env, jclass jc);
  JNIEXPORT jdouble JNICALL Java_JNI_CPNative_getInvDistance(JNIEnv* env, jclass jc);
  JNIEXPORT jstring JNICALL Java_JNI_CPNative_getTopology(JNIEnv* env, jclass jc);
  JNIEXPORT jintArray JNICALL Java_JNI_CPNative_getList(JNIEnv* env, jclass jc, jint pnum,jint idx,jint flag);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_getListCount(JNIEnv* env, jclass jc, jint pnum,jint idx,jint flag);
  JNIEXPORT jdoubleArray JNICALL Java_JNI_CPNative_getMobius(JNIEnv* env, jclass jc);
  JNIEXPORT jboolean JNICALL Java_JNI_CPNative_showAxis(JNIEnv* env, jclass jc);
  JNIEXPORT void JNICALL Java_JNI_CPNative_setCLineThick(JNIEnv* env, jclass jc,jint packnum,jint jpixels,jint jflag);
  JNIEXPORT jint JNICALL Java_JNI_CPNative_sendmeSidePairs(JNIEnv* env,jclass jc,jint packnum);
  JNIEXPORT jdoubleArray JNICALL Java_JNI_CPNative_getCircleIndex(JNIEnv* env,jclass jc,jint packnum,jdouble x,jdouble y);
}

void drawCircle(int packnum,double x, double y, double r);
void drawFilledCircle(int packnum, double x, double y,double rad, int r, int g, int b);
void drawColorCircle(int packnum, double x, double y,
			double rad, int r, int g, int b);
void drawFilledColorCircle(int packnum, double x, double y,double rad, int r, int g, int b, int br, int bg, int bb);
			
void drawFace(int packnum,double x1,double y1,double x2,double y2,double x3,double y3);
void drawFilledFace(int packnum,double x1, double y1, double x2, double y2,
			double x3, double y3,int r,int g,int b);
void drawColorFace(int packnum,double x1, double y1, double x2, double y2,
			double x3, double y3,int r,int g,int b);
void drawFilledColorFace(int packnum,double x1, double y1, double x2, double y2,
			double x3, double y3,int r,int g,int b,int br,int bg,int bb);
			
void drawEdge(int packnum,double x, double y, double x2, double y2);
void drawColorEdge(int packnum,double x1, double y1, double x2, double y2,int r,int g,int b);

void drawIndex(int packnum,double x,double y,int n,int msg_flag);

void showMsgBuf(int msgflag,char *msg);
void showErrorMsgBuf(int errflag,char *errmsg);
void showScratchMsg(int msgflag,char *msg);
void showDebugMsg(int msgflag,char *debugmsg);
void setMatrix(struct p_data *p);
void setViewBox(struct p_data *p);
void clearCanvas(int packnum);
void setPackName(int packnum,char *datastr);
void setActive(int act);
void drawPath(int packnum,int length);
void updateWorld(int packnum);
void setAxisMode(int packnum,int flag);
void setGeometry(int packnum,int hes);
void setLineThick(int packnum,int thick);
void resetPack(int packnum);
int setFtnText(char *ftn_text);
complex returnFtnValue(complex z,int *errflag);
complex gogetFtnValue(complex z);
int setFlagOptions(int pnum,int cflag_opt,int fflag_opt);
void loadScript(char *datastr);
int openMap(int p,int q);
int closeMap();
int drawUnitCircle(struct p_data *p);
int drawEquator(struct p_data *p,double re,double im);
int runSpecialCmd(char *datastr);
int setMobius(struct p_data *p,int MobType,char *name,Mobius mob);
int flushSidePairs(struct p_data *p);
int refresh();
int callInfileRead(char *filename,int mode);
int scriptWriteFile(int act,int append_flag,int mode,char *filename);

#endif
