/* StandAlone_proto.h   These are procedure prototypes for things specific
   to SA and the sa_*.c files (whereas sa_proto.h is for
   the more generic library routines */

#ifndef __CIRCLEPACK_PROTO_H__
#define __CIRCLEPACK_PROTO_H__

#include "sa_types.h"
#include "sa_head.h"

/* cp_action.c */
char *find_script_data(char *datastr,int flag);
int canvas_life(int pnum,int act);
int chg_active_pack(int pnum);
int cmd_up(int sflag);
int exe_named_cmd(char *datastr,int *targ_p);
int find_next_script_cmd(int direction,int ex_flag);
char *find_script_data(char *datastr,int flag);
int help_proc();
int quit(int flag);
int script_up_proc();
int set_packing_path();
int save_workspace();
int screen_num(struct s_data *q);
int setup_proc();

/* sa_call.c */
int compress_call(char *datastr);
int pack_num(struct p_data *p);
struct Vertlist *node_link_parse(struct p_data *p,char *dpoint,
				 char **endptr,int *hits);
struct Vertlist *face_link_parse(struct p_data *p,char *dpoint,
				 char **endptr,int *hits);
struct Edgelist *node_pair_link(struct p_data *p,char *dpoint,
				char **endptr,int *hits);
int cmd_search(char *datastr,int *shift);
int match_call(struct p_data *p,char *datastr);
int blend_call(struct p_data *p,char *datastr);
int plug_call(struct p_data *p,char *datastr);
int path_construct_call(struct p_data *p,char *datastr);
int vert_order_call(struct p_data *p);
int get_put_data_call(struct p_data *p,char *datastr,int rev_flag);
int cir_invert_call(struct p_data *p,char *datastr);
int molify_call(struct p_data *p,char *datastr);
int cookie_call(struct p_data *p,char *datastr);
int diag_call(struct p_data *p,char *datastr);
int reverse_orient_call(struct p_data *p);
int add_circles_call(struct p_data *p,char *datastr);
int geom_to_e_call(struct p_data *p,char *datastr);
int geom_to_h_call(struct p_data *p,char *datastr);
int geom_to_s_call(struct p_data *p,char *datastr);
int riffle_call(struct p_data *p,int passes,int lpr,int flag);
int gen_cut_call(struct p_data *p,char *datastr);
int gen_mark_call(struct p_data *p,char *datastr);
int spiral_call(struct p_data *p,char *datastr);
int proj_max_to_s(struct p_data *p,char *datastr);
int NSpole_call(struct p_data *p,char *datastr);
int rect_ratio_call(struct p_data *p,char *datastr);
int marking(struct p_data *p,char *datastr);
int norm_scale_call(struct p_data *p,char *datastr);
int set_aim_call(struct p_data *p,char *datastr);
int randize(struct p_data *p,char *datastr);
int max_pack(struct p_data *p,char *datastr);
int reset_screen(struct s_data *q);
int enfoldcall(struct p_data *p,char *datastr);
int adjoincall(struct p_data *p,char *datastr);
int zip_call(struct p_data *p,char *datastr);
int color_circles(struct p_data *p,int f,char *datastr);
int color_faces(struct p_data *p,int f,char *datastr);
int map_list_call(struct p_data *p,char *datastr);
int adjacency_call(struct p_data *p,char *datastr,int pflag);
int write_multi_call(struct p_data *p,char *datastr,int call,int pflag);
int write_light_call(struct p_data *p,char *datastr,int flag,int pflag);
int write_parse(struct p_data *p,char *datastr,int pflag);
int create_parent_call(struct p_data *p,char *datastr);
int timedelay(double tm);
int set_overlapscall(struct p_data *p,char *datastr);
int set_screen_call(struct p_data *p,char *datastr);
int set_postfile_call(int flag,char *datastr);
int find_help_packrc(char *argv0);
int read_packrc(char *filename);
int read_rgb_file(char *rgb_filename);
int hex_parallel_call(struct p_data *p,int v,int w,int n,complex *cmod,
		      int show);
struct Vertlist *try_hex_pg(struct p_data *p,int v,int w,int n,
			    int *v1,int *v2,int *v3,int *v4);
int j_ftn_call(struct p_data *p,char *datastr);
int mend_call(struct p_data *p,char *datastr,int totalpasses);
int h_dist_call(char *datastr);
int focus_call(struct p_data *p,char *datastr);
int call_torus_t(struct p_data *p,char *datastr);
int gen_islands_call(struct p_data *p,char *datastr);
int add_ideal_call(struct p_data *p,char *datastr);
int slit_complex_call(struct p_data *p,char *datastr);
int set_screen_call(struct p_data *p,char *datastr);
int dilatation_call(struct p_data *p,struct p_data *q,double *kmax,int *face);
int face_error_call(struct p_data *p,char *datastr);
int pin_face_call(struct p_data *p,char *datastr);
int brooks_call(struct p_data *p,char *datastr);
int locate_call(struct p_data *p,char *datastr);
int embed_call(struct p_data *p,char *datastr);
int holonomy_trace(struct p_data *p,char *datastr,Mobius *Mob);
int weld_call(char *datastr);

/* sa_cmd.c */

int sort_cmd(const char *cmd_stream,int *targ_p);
int handle_cmd(char *command,int *targ_p);
int parse_cmd(struct p_data *p,int *hflag,int *targ_p);
int doyle_point_call(struct p_data *p,char *datastr);

/* cp_format.c */

int frame_builder();
int set_window_rects();
int create_panel_sw();
int create_script_frame();
int create_config_win();
int create_screen_popups();
int create_subwindows();
int create_canvas_frames();
int create_manip_frame();
int create_cursors();

/* sa_io.c */

int readcall(struct p_data *p,char *filename);
int call_read_pack(FILE *fp,struct p_data *p,char *packname);
int writecall(struct p_data *p,char *filename,int act);
int write_consolidate(struct p_data *p,char *filename);
int open_and_write(struct p_data *p,char *filename,int act);
int read_path_file(char *filename);
int write_path_file(char *filename);
int copy_packcall(char *datastr);
int seed_start_call(struct p_data *p,char *datastr);
int empty_pack(struct p_data *p);
int confirm_action(char *message);
int confirm_continue(char *message);
int print_inq_data(struct p_data *p,int f,char *datastr);
int reset_script();
int find_script_proc();
int read_infile(struct p_data *p,char *datastr);
int read_raw_infile(char *datastr,char **tmpname);
int cmds_infile(char *datastr);
int path_infile(char *datastr);
int fexec_call(char *datastr);
int c_initmem();
int c_rdmem(int *vnum,char *vstr);
int c_wrmem(int *vnum,char *vstr);
int cmd_import(char *datastr);
int cmd_export(struct p_data *p,char *datastr);
char *get_selection(int kill);
int stat_file(char *filename);
int post_canvas(struct p_data *p);
int print_psfile(FILE **FP);

/* sa_screen.c */

int display_call(struct p_data *p,char *datastr);
int disp_screen(struct p_data *p,int cflag,int fflag,int show);
int coord_axes(struct p_data *p);
int caption(struct s_data *q,char *datastr);
int clear_canvas(struct s_data *q);
int draw_in_order(struct p_data *p,int cflag,int fflag,int pl,int show);
int refresh_canvas(struct s_data *q);
int layout_report(struct p_data *p,int v,int flag);
int set_cursor(struct s_data *q,int m);
int msg();
int emsg();
int smsg();
int hmsg(char *msg);
int pmsg(int i,char *msg);
int msg_remote(int i);
int set_pack_labels();
int repack_activity_msg(char *datastr);
int sphere_view(struct s_data *q,char *datastr);

/* sa_special.c */

int create_special_menu();
int special1(char *datastr);
int special2(char *datastr);
int special3(char *datastr);
int special4(char *datastr);
int special5(char *datastr);
int special6(char *datastr);
int special7(char *datastr);
int special8(char *datastr);
int special9(char *datastr);

/* cp_xview.c */

int set_print_file(char *datastr);
int set_ps_file(char *datastr);
int set_pack_dir_name(char *datastr);
int set_print_cmd(char *datastr);
char *get_print_file();
char *get_ps_file();
char *get_pack_dir_name();
char *get_print_cmd();
int set_u_cir_flag(int pnum,int truefalse);
int set_coord_flag(int pnum,int truefalse);
int set_script_name(char *filename);

#endif
