/* sa_proto.h     procedure prototypes for circle packing library   */

#include "sa_types.h"
#include "complex_math_proto.h"
#include "hyp_math_proto.h"
#include "eucl_math.h"
#include "sph_math.h"

//#ifndef WIN32
//#include "cp_canvas_proto.h"
//#endif

//#ifdef __cplusplus
//#define __CP_PROTO(func, args) extern "C" { func args }
//#else
//#define __CP_PROTO(func, args) extern func args
//#endif

int msg();
int emsg();
int debugmsg();
int handle_cmd(char *command,int *targ_p);
struct Edgelist *node_pair_link(struct p_data *p,char *dpoint,
				char **endptr,int *hits);
struct Vertlist *face_link_parse(struct p_data *p,char *dpoint,
				 char **endptr,int *hits);
int fancy_comp_center(struct p_data *p,int vert,int n0,int n1,int n,
		 int flag,int opt,int npf,double crit);
int h_compcenter(complex z1,complex z2,complex *z3,
		 double s1,double s2,double *s3,
		 int ol_flag,double o1,double o2,double o3);
int molify_pack_centers(struct p_data *p,int flag,
			struct Vertlist *vertlist);
int molify_center(struct p_data *p,int v);
int incr_generations(struct p_data *p,struct Vertlist **seed_list,
		int *mark_count,int *min_gen,int target_size);
int print_call(FILE **FP,struct p_data *p,char *filename,
	       char *datastr,char *user_name,char *Message,
	       char *print_cmd);
int get_put_data(struct p_data *p,struct p_data *q,
	     char *datastr,char flag,int rev_flag,int trans_flag);
int color_circles(struct p_data *p,int f,char *datastr);
int color_faces(struct p_data *p,int f,char *datastr);
int r_to_pix(complex pt, complex *normpt,Pix_box pix_box,Box box);
int line_ck(complex end1, complex end2, Box box);
int cir_ck(complex ctr,double rad,Box box); 
int geo_ck(hyp_geodesic hg,Box box);
int fillcurves(struct p_data *p);
int adjust_radii(struct p_data *p,char *datastr);
int h_changerad(struct p_data *p,int i,double newr);
int e_changerad(struct p_data *p,int i,double newr);
int s_changerad(struct p_data *p,int i,double newr);
int apply_pair_mobius(struct p_data *p,char *datastr);
int e_norm_scale(struct p_data *p,char *datastr);
int eucl_scale(struct p_data *p,double factor);
int pair_mobius(struct p_data *p,int n);
int find_paired_centers(struct p_data *p,struct RedList *redface,
			int e_indx,complex *c1,complex *c2);
int e_norm_pack(struct p_data *p,complex a,complex g);
int update_pair_mob(struct p_data *p);
int apply_Mobius(struct p_data *p,char *datastr,int flag,Mobius Mob);
int rotate(struct p_data *p,double ang);
int center_point(struct p_data *p,complex ctr);
int spiral(struct p_data *p,double a,double b);
int h_norm_pack(struct p_data *p,complex c,complex d);
int fill_star_curves(struct p_data *p,int v);
int normalize_star(struct p_data *p,int v,double radius);
int any_compcenter(struct p_data *p,complex z1,complex z2,complex *z3,
		   double r1,double r2,double *r3,
		   double o1,double o2,double o3);
int bdry_dist(struct p_data *p,complex pt,double *b_dist,double *b_vert_dist);
int e_anglesum_overlap(struct p_data *p,int v,double r,double *c,int *flag);
int s_anglesum_overlap(struct p_data *p,int i,double r,double *c,int *flag);
int h_as_overlap(struct p_data *p,int i,double s,double *c,
		 int *flag,double *incompat_err);
int e_as_overlap(struct p_data *p,int v,double r,double *c,
		 int *flag,double *incompat_err);
int h_anglesum_overlap(struct p_data *p,int i,double s,double *c,int *flag);
int norm_any_pack(struct p_data *p,complex a,complex g);
int place_face(struct p_data *p,int face,int indx);
int comp_center_face(struct p_data *p,int f,int flag);
int max_pack(struct p_data *p,char *datastr);
int repack_call(struct p_data *p,char *data);
int sa_reset_screen(struct p_data *p);
int select_vertex(struct p_data *p,int *index,int aimnum);
int s_radcalc_norm(struct p_data *p,double valence);
int ck_s_compat(struct p_data *p,int nf);
int s_deriv_sign(struct p_data *p,int i,double r);
int branch_order(struct p_data *p);
int h_curvcalc(struct p_data *p,int i,double s,double *c,double *d);
int call_test_repack(struct p_data *p,char *datastr);
int test_riffle(struct p_data *p,int passes,int test_cycles,
		int cmd,double tol);
int ck_pack_status(struct p_data *p,double tol);
int comparison(char *datastr,double x,double y);
int paren_parse(char **datastr,int *v,int *w);
int path_wrap(struct p_data *p,complex pt);
int symb_to_value(struct p_data *p,char *datastr,int node,int cf,double *val);
int check_red_chain(struct p_data *p);
int diag_hanging_verts(struct p_data *p);
int diag_small_rads(struct p_data *p);
int diag_int_connected(struct p_data *p);
int cir_placement_data(struct p_data *p,int v);
int diag_layout_quality(struct p_data *p,double *factor,
			int *count,int *err_count,int opt_flag);
int placement_err(struct p_data *p,double tolr);
int ideal_bdry_node(struct p_data *p,int v);
int complex_count(struct p_data *p,int flag);
int gen_mark(struct p_data *p,char *datastr);
int remove_edge(struct p_data *p,int v1,int v2);
int swap_nodes(struct p_data *p,int v,int w);
int swap_nodes_call(struct p_data *p,char *datastr);
int reverse_orient(struct p_data *p);
int double_K(struct p_data *p,char *datastr);
int adjoin(struct p_data *p1,struct p_data *p2,
	   int v1,int v2,int n,int **Oldnew);
int close_up(struct p_data *p,int vert);
int set_radii(struct p_data *p,double rad,char *datastr);
int set_centers(struct p_data *p,complex ctr,char *datastr);
int set_xyz_overlaps(struct p_data *p,struct xyzPoint *xyz_list,
		     int count,char *datastr,int flag);
int set_single_overlap(struct p_data *p,int v,int j,double angle);
int add_circles(struct p_data *p,char *datastr);
int seed_pack(struct p_data *p,int hes,int n);
int copy_pack(struct p_data *p1,struct p_data *p2);
int copy_redlist(struct p_data *p2,struct p_data *p1);
int set_default_overlaps(struct p_data *p);
int set_plot_flags(struct p_data *p,char *datastr);
int add_vert(struct p_data *p,int v);
int enfold(struct p_data *p,int p1);
int slit_complex(struct p_data *p,struct Vertlist *vertlist);
int open_edge(struct p_data *p,int v,int w);
int add_layer(struct p_data *p,char *datastr,int *flag);
int add_generation(struct p_data *p,char *datastr);
int add_barys(struct p_data *p,char *datastr);
int add_barycenter(struct p_data *p,int f);
int split_flips(struct p_data *p,char *datastr,int flag);
int split_edge(struct p_data *p,int v,int w);
int flip_edge(struct p_data *p,int v,int w,int flag);
int hex_refine(struct p_data *q);
int bary_refine(struct p_data *p);
int vert_for_edge(struct p_data *p,int v,int j);
int gen_cut(struct p_data *p,int v,int gen);
int face_ready(struct p_data *p,int face,int *index);
int readpack(FILE *fp,struct p_data *p);
int writepack(FILE *fp,struct p_data *p,int act,int append);
int readpath(FILE *fp,struct Pathlist **pathlist,int *pathlength);
int points_to_path(double *points,int size,struct Pathlist **pathlist,int *pathlength);
int new_readpath(std::ifstream &infile,struct Pathlist **pathlist,int *pathlength); // FA
int writepath(FILE *fp,struct Pathlist *pathlist);
int new_writepath(std::ofstream &outfile,struct Pathlist *pathlist); // FA
int write_vert_list(struct p_data *p,char *filename,char *datastr);
int write_select_r_c(struct p_data *p,char *filename,
		     char *datastr,int flag);
int write_tri_verts(struct p_data *p,char *datastr);
int read_light(FILE *fp,struct p_light **plight,int flag);
int write_light(FILE *fp,struct p_light *pl,int flag);
int write_light_as_full(FILE *fp,struct p_light *pl,int flag);
int read_parent_child(char *filename,struct p_data *parentpacking,
		      struct p_light ***plight, int *overlap);
int output_mobius(FILE *fp,Mobius mob);
int reset_screen_box(struct s_data *q,int width,int height);
int post_any_geo(FILE *fp,struct p_data *p,complex a,complex b,
	       int eflag,int col);
int post_in_order(FILE *fp,struct p_data *p,int cflag,int fflag,int pl);
int post_shape(FILE *fp,char symb);
int post_any_polygon(FILE *fp,struct p_data *p,
		     struct Vertlist *vertlist,int eflag,int ecol,int col);
int e_compcenter(complex z1,complex z2,complex *z3,
		 double e1,double e2,double *e3,
		 double o1,double o2,double o3);
int e_to_h_data(complex e_center,double e_rad,
		complex *h_center,double *x_rad);
int h_to_e_data(complex h_center,double x_rad,
		complex *e_center,double *e_rad);
int circle_3(complex z1,complex z2,complex z3,complex *c,double *rad);
int h_horo_center(complex z1,complex z2,complex *z3,
		  double e2,double *s3,
		  double o1,double o2,double o3);
int h_geodesic(complex a,complex b,hyp_geodesic *hg);
int tangent(complex ctr1,complex ctr2,double *T);
int s_compcenter(complex z1,complex z2,complex *z3,
		 double r1,double r2,double *r3,
		 double o1,double o2,double o3);
int s_pt_to_vec(complex z,double *V);
int s_to_e_data(complex z,double r,complex *e,double *er);
int e_to_s_data(complex z,double r,complex *s,double *sr);
int pt_in_sph_tri(complex pt,complex z1,complex z2,complex z3);
int sph_rotation(double alpha,double beta,double gama,double M[3][3]);
int mat_mult(double A[3][3],double B[3][3],double C[3][3]);
int s_to_matrix_data(complex center,double rad,Mobius *C);
int matrix_to_s_data(Mobius C,complex *center,double *rad);
int blue_to_red_ramp(int flag);
int find_path_int(struct p_data *p);
int comp_pack_centers(struct p_data *p,int errflag,int dflag,int opt,
		     double crit);
int writeeucldata(struct p_data *p,char *filename);
int NS_mobius(complex zN,complex zS,complex zE,
	      double rN,double rS,double rE,double factor,
	      int *errflag,Mobius *Mob);
int e_pack_light_uniform(struct p_light *pl,int passes,double tolr,
		      int repack_method,long *elapsetime);
int h_pack_light_uniform(struct p_light *pl,int passes,double tolr,
		      int repack_method,long *elapsetime);
int layer_decompose(struct p_data *p,struct p_light **grains,
		    int spread,int overlp,int mx,int max_grains);
int vert_draw_order(struct p_data *p);
int flat_hex(struct p_data *p,char *datastr);
int rect_ratio(struct p_data *p,char *datastr,double *aspect);
int adjacency(FILE *pf,struct p_data *p,int flag);
int build_j_function(struct p_data *p,int n0,int n1,int maxsize);
int identify_nghbs(struct p_data *p,int v,int *alive,int *dead);
int grab_one_vert(struct p_data *p,char **ptr);
int grab_one_face(struct p_data *p,char **ptr);
int screen_focus(struct s_data *p,complex ctr);
int comb_deep_ck(struct p_data *p,int *vert);
int convert_from_p_light(struct p_data *p,struct p_light *pl,int flag);
int sphere_view(struct p_data *p,char *datastr);
int set_screen(struct p_data *p,char *datastr);
int fix_call(struct p_data *p,char *datastr);
int msg();
int emsg();
int time_to_hms(long elapsetime,int *hr,int *min,int *sec);
int set_CPack_globals();
int add_ideal(struct p_data *p,struct Vertlist *vertlist);
int gen_islands(struct p_data *p,int seed, char *datastr);
int path_Mobius(Mobius mob,struct Pathlist *plist,int flag);
int plug_it_up(struct p_data *p,int seed);
int sa_polygon(struct p_data *p,struct Vertlist *vertlist,
	       int eflag,int ccol,int col);
int brooks_construct(struct p_data *p,int v,int w,
		     struct Vertlist *VH_list,int flag,int cflag);
int brooks_insert(struct p_data *p,int P,int ,int v,int flag);
int nan_check(struct p_data *p,char *datastr);
int write_carrier_file(struct p_data *p,char *datastr);
int surf_write(struct p_data *p,char *datastr);
int read_colortable(struct p_data *p,char *datastr);
int sa_send_colors(int canv_num,char *tablename,char *filename,
		   int opts,int flag);
int read_rgb_file(char *rgb_filename);
int print_transition(struct p_data *p,FILE *fp,int opt);
int holonomy_trace(struct p_data *p,char *datastr,Mobius *Mob);
int msg_mobius_info(Mobius mob);
int scale_aims(struct p_data *p,double x,struct Vertlist *vlist);
int scale_aims_call(struct p_data *p,char *datastr);
int scale_rad(struct p_data *p,struct p_data *q,double x,
	      struct Vertlist *vlist);
int scale_rad_call(struct p_data *p,struct p_data *q,char *datastr);
int flip_priority_call(struct p_data *p,char *datastr);
int set_radii_call(struct p_data *p,char *datastr);
int get_xyz_data(struct p_data *p,char *datastr);
int alt_rect_pack(struct p_data *p,char *datastr);
int sq_grid_layer(struct p_data *p,int *startv,int *endv);
int sq_grid_lay_call(struct p_data *p,char *datastr);
int sq_grid_overlaps(struct p_data *p);
int erf_ftn(struct p_data *p1, struct p_data *p2,int n);
int square_fit(struct p_data *p);
int doyle_annulus(struct p_data *p,char *datastr);
int beurling_call(struct p_data *p,char *datastr);
int beurling_flow(struct p_data *pd,struct p_data *pr,
		  double t,double xpnt,complex w0,int option);
int doyle_point_call(struct p_data *p,char *datastr);
int create_parent(struct p_data *p,FILE *fp,int N);
int aspect(struct p_data *p,char *datastr);
int weld_call(char *datastr);
int sph_test_disp(struct p_data *p);
int transition_data_call(struct p_data *p,char *datastr);
int init_remote(char *datastr,int *rp_num);
int open_service(struct remote_control *pc,char *command,char *datastr);
int reset_lock(struct p_data *p,int hit,int flag);
int check_lock(struct p_data *p,int proc);
int tent_call(struct p_data *p,char *datastr);
int col_to_table(int rd, int gn, int bl);
int showlists(struct p_data *p,int flag);
int h_g_bar(struct p_data *Hp, struct p_data *Gp, struct p_data *Fp);
int h_g_bar_call(char *datastr);
int new_pack_setup(struct p_data *p);
int switch_geom(struct p_data *p);
int send_setViewBox(struct p_data *p);
int set_ftn_text(char *ftn_name);
int updateSidePairs(struct p_data *p);
int sa_send_flag_opts(struct p_data *p);
int sa_read_script(char *datastr);
int map_activity(struct p_data *p,struct p_data *q,char *datastr);
int Map_call(char *datastr);
int set_ratio(struct p_data *p0,struct p_data *p1);
int set_line_thick(struct p_data *p,int jpixels,int jflag);
int find_mate_index(struct p_data *p,int e);
int random_pack_call(struct p_data *p,char *datastr);
int tree_pack_call(struct p_data *p,char *datastr);
int trans_rectify_vlist(struct p_data *p,struct p_data *q,struct Vertlist **list);
int rectify_vlist(struct p_data *q,struct Vertlist **list);

char *ptr_to_name_at_end(char *datastr,int *flag);

long get_time();

double check_red_layout(struct p_data *p);
double dot_prod(double V[3],double W[3]);
double cross_prod(double X[3],double Y[3],double Z[3]);
double vec_norm(double X[3]);
double aTan2(double y,double x);
double s_dist(complex z1,complex z2);
double s_comp_cos(double r1,double r2,double r3,int *flag);
double h_comp_x_cos(double x1,double x2,double x3);
double h_area(double x1,double x2,double x3);
double h_cos_s_overlap(double s1,double s2,double s3,
		     double t1,double t2,double t3,int *flag);
double h_cos_s_overlap_special(double s1,double s2,double s3,
			     double t1,double t2,double t3,int *flag,
			     double *incompat_err);
double x_to_s_rad(double x);
double s_to_x_rad(double s);
double h_horo_rad(double s1,double ovlp);
double comp_single_angle(struct p_data *p,int v,int u,int w,int *flag);
double radius_pl(struct p_light *pl,int v);
double radius(struct p_data *p,int v);
double s_star_area(struct p_data *p,int v);
double gwrand();
double max_r_adjustment (struct p_data *p,int v);
double seg_dist(complex pt,complex p1,complex p2);
double comp_inv_dist(struct p_data *p,int v,int w);
double xyz_inv_dist(struct xyzPoint xyz,struct xyzPoint XYZ,
		    double r,double R);
double curv_aim_error(struct p_data *p);
double e_radcalc(struct p_data *p,int i,double r,double aim,int *chgflag);
double h_radcalc(struct p_data *p,int i,double s,double aim,int *chgflag);
double s_radcalc(struct p_data *p,int v,double r,double aim,int *chgflag);
double s_carrier_area(struct p_data *p);
double h_radcalc_binary(struct p_data *p,int i,double s,double aim,
			int *chgflag,int cmd);
double e_radcalc_binary(struct p_data *p,int i,double s,double aim,
			int *chgflag,int cmd);
double invdist_err(struct p_data *p,int v,int w);
double e_area(double r1,double r2,double r3);
double e_cos_overlap(double e1,double e2,double e3,
		     double t1,double t2,double t3,int *flag);
double R3_dist(complex z,complex w);
double e_cos_overlap_special(double e1,double e2,double e3,
			     double t1,double t2,double t3,
			     int *flag,double *incompat_err);
double Fx(double x,double y,double z);
double Fy(double x,double y,double z);
double Fz(double x,double y,double z);
double cAbs(complex z);
double Arg(complex w);
double inv_dist(complex z1,double r1,complex z2,double r2);

complex pix_to_r(int x, int y,Pix_box pix_box,Box box);
complex cadd(complex z1,complex z2);
complex cmult(complex z1,complex z2);
complex csub(complex z1,complex z2);
complex cconj(complex z1);
complex cdiv(complex z1,complex z2);
complex cExp(double r,double t);
complex cProj(complex w);
complex cLog(complex w);
complex proj_pt_to_sph(double x,double y);
complex proj_vec_to_sph(double x,double y,double z);
complex ss_view(struct s_data *q,complex pt,int flag,int *front);
complex proj_to_sph(double a,double b);
complex s_pt_to_visual_plane(complex pt);
complex screen_to_s_pt(complex pt,int *hit);
complex sph_tri_center(complex z1,complex z2,complex z3);
complex torus_t(struct p_data *p,int *flag);
complex face_center(struct p_data *p,int face);
complex get_java_ftn_value(complex z);

char *pair_picking(char *datastr,char start_char,char end_char,char **endptr);

struct xyzPoint *read_xyz(FILE *fp,char *datastr,int *count);
struct xyzPoint *read_xyz_buf(char *buf,char *datastr,int *count);

struct p_light *convert_to_p_light(struct p_data *p);

struct Vertlist *rectify_flist(struct p_data *p,struct Vertlist *list);
struct Vertlist *parse_facepath(struct p_data *p,struct Pathlist *path,
				int *livenode);
struct Vertlist *path_construct(struct p_data *p,int flag,char *datastr);
struct Vertlist *try_hex_pg(struct p_data *p,int v,int w,int n,
			    int *v1,int *v2,int *v3,int *v4);
struct Vertlist *Node_link_parse(struct p_data *p,char *dpoint,
				 char **endptr,int *hits,
				 struct Vertlist **Vlist,
				 struct Edgelist **Elist,
				 struct Vertlist **Flist,
				 CPRegion *region,struct Pathlist *pathlist,
				 int pathlength);
struct Vertlist *Face_link_parse(struct p_data *p,char *dpoint,
				 char **endptr,int *hits,
				 struct Vertlist **Vlist,
				 struct Edgelist **Elist,
				 struct Vertlist **Flist,
				 CPRegion *region,struct Pathlist *pathlist,
				 int pathlength);
struct Edgelist *Node_pair_link(struct p_data *p,char *dpoint,
				char **endptr,int *hits,
				struct Vertlist **Vlist,
				struct Edgelist **Elist,
				struct Vertlist **Flist,
				CPRegion *region,struct Pathlist *pathlist,
				int pathlength);
struct Edgelist *legal_edges(struct p_data *p,char *datastr);
struct Edgelist *flip_priority(struct p_data *p,char *datastr);
struct Vertlist *brace_parse(struct p_data *p,char *datastr,
			     int *n_flag,char **lastptr,
			     struct p_data *pack_data);
struct Vertlist *path_follow(struct p_data *p,
			     struct Edgelist *edgelist,int flag);
struct Vertlist *extended_edge_verts(struct p_data *p,int v1,int v2,int lgth);
struct Edgelist *get_extended_edge(struct p_data *p,int v1,int v2,int lgth);
struct Edgelist *node_to_edge(struct p_data *p,struct Vertlist *vertlist);

struct Pathlist *s_geodesic(complex z1,complex z2,int num_plot);
struct Pathlist *full_s_geodesic(complex z1,complex z2,int num_plot);
struct Pathlist *s_circle_list(complex ctr,double r,int num_plot);
struct Pathlist *sph_tri_list(complex z0,complex z1,complex z2,int num_plot);
struct Pathlist *fix_convex_list(struct Pathlist *inlist);
struct Pathlist *sph_poly_list(struct s_data *q,struct Centlist *c_list);

struct RedList *build_gen_redlist(struct p_data *p,int seed,
				  int *vec_seed,int gen,int *count);
struct RedList *red_from_outlist(struct p_data *p,struct Edgelist *elist);
struct Edgelist *red_to_outlist(struct p_data *p,int mode);
struct BdryData *organize_bdry_data(struct p_data *p,
				    struct RedList *redlist);
struct BdryData *drop_bd(struct BdryData **ptr,struct BdryData **bd_ptr);

CPXPoint *path_XPoints(struct s_data *q,struct Pathlist *path,int *length);

f_data  *tailor_face_order(struct p_data *p,int flag,int *first_face);

f_data  *simple_layout(struct p_data *p,int option_flag,
		       int *first_face);
/* quality_stuff.cpp   for finding layout error info */
int face_error(struct p_data *p,double crit,struct Vertlist *facelist);
int pin_face(struct p_data *p,int face);
double desired_length(struct p_data *p,int v,int w);
double edge_length(struct p_data *p,int v,int w);

/* fix_Pages_stuff.cpp   for renumbering postscript Pages */

int renumber_ps_Pages(char *filename);
long find_Page(FILE *fp,long *start,int flag);
int count_Pages(FILE *fp);

/* simplify_redchain.cpp  for finding simply connect subcomplex */
int simplify_redchain(struct p_data *p,struct RedList **redlist,
		      struct Edgelist *lifeline,int keep_vert,
		      struct RedList *keep_ptr);
int ck_in_elist(struct Edgelist *elist,int v,int w);
struct RedList *build_fan(struct p_data *p,int vert,int indx1,
			  int indx2,int *flag,int *count);
int jump_down_red(struct p_data *p,struct RedList *start,int start_vert,
		  struct RedList **new_ptr,struct RedList *keep_ptr,
		  int *hit_flag);
struct RedList *upstream_red(struct p_data *p,int vert,
			     struct RedList *redlist,int *up_indx);
struct RedList *downstream_red(struct p_data *p,int vert,
			       struct RedList *redlist,int *down_indx);

/* remote_comm_stuff.cpp for commun between CirclePack and remote processes */
int r_msg(char *msg);
int r_emsg(char *msg);
int r_cmsg(char *msg);
int r_dmsg(char *msg);
int r_lock_set(int pnum);
int r_unlock(int pnum);
int r_pack_read(struct p_data *p,int pnum,int opt);
int r_pack_write(struct p_data *p,int qnum,int opt);
int r_path_read(struct Pathlist **pathlist,int *pathlength);
int r_path_write(struct Pathlist *pathlist,int pathlength);
int r_get_pack_size(FILE *fp,struct p_data *p);
int r_done_signal();

/* layout_stuff.cpp */
int layout_report(struct p_data *p,int v,int flag);
int layout_facelist(struct p_data *p,struct Vertlist **facelist,
		    int fix,int l_face);

/* random_walk_stuff.cpp */
double G(double x,double y,double z);
double G1(double x,double y,double z);
double G2(double x,double y,double z);
double G3(double x,double y,double z);
double g(double x,double y,double z);
double g1(double x,double y,double z);
double g2(double x,double y,double z);
double g3(double x,double y,double z);
double area_div(struct p_data *p,int v);
double Av(double v,double u,double w);
double dtheta_dlog(struct p_data *p,int v);
double twin_conductance(struct p_data *p,int v);
double Cvw(double v,double u,double w,double a,int flag,int hes);
double node_conductance(struct p_data *p,int v);
double edge_conduct(struct p_data *p,int v,int indx);

/* gauss_curv_stuff.cpp Gaussian curvature stuff */
int kappa_calc(struct p_data *p,int v,double *kap);
double pos_k_angle_sum(double c,double *R,int m);
double neg_k_angle_sum(double c,double *R,int m);
int color_kappa(struct p_data *p,double base);

/* set_color_stuff.cpp */
int radius_col_comp(struct p_data *p);
int area_col_comp(struct p_data *p);
int color_qc(struct p_data *p,struct p_data *q,char *datastr,
	     double *kmax);
int color_qc_xyz(struct p_data *p,struct xyzPoint *xyz_list,
		 int xyzcount,char *datastr,double *kmax);
int h_compare_area(struct p_data *p,struct p_data *q);
int h_compare_cl(struct p_data *p,struct p_data *q);
int e_compare_cl(struct p_data *p,struct p_data *q);
int e_compare_area(struct p_data *p,struct p_data *q);

/* map_stuff.cpp */
int vertex_translation(struct Edgelist *vertex_map,int v);
int vertex_rev_translation(struct Edgelist *vertex_map,int w);
int face_translation(struct p_data *p,int nf,struct p_data *q);
int face_rev_translation(struct p_data *p,int nf,struct p_data *q);
int map_list(struct p_data *p,struct p_data *q,char *datastr,
	     int mode,int rev_flag);

/* weld_map.cpp */
int weld_map(struct p_data *p,struct p_data *q,int v,int w,
	     char *filename,int out_flag);
int weld_map_call(struct p_data *p,struct p_data *q,char *datastr);

/* unwell.cpp */
int unweld(struct p_data *p,struct p_data *q,
	   struct Edgelist *elist,int oi_flag);
int unweld_call(struct p_data *p,struct p_data *q,char *datastr);

/* williams_weld.cpp */
int weld_map_to_list(struct p_data *p, struct p_data *q, 
		     int p_start_vert, int q_start_vert, 
		     int p_count, int q_count,
		     char *weldmapfile, char *weldlistfile,int opt_flag);
int readweldmap(char *weldmapfile,
		struct Pathlist **path_list,int *path_length);
int weld(struct p_data *p,struct p_data *q,int v,int w,
	 char *weldlistfile,int opt_flag);
int add_between(struct p_data *p,int v,int v_next);
int weld_using_map(struct p_data *p,struct p_data *q,
		   int p_start_vert,int q_start_vert,
		   int p_count,int q_count,char *weldmapfile,int opt_flag);



/* set_face_stuff.cpp setting technical parameters of faces */
int set_face_next(struct p_data *p,char *datastr);
int set_face_index(struct p_data *p,char *datastr);
int set_face_red(struct p_data *p,char *datastr);
int set_face_rnext(struct p_data *p,char *datastr);

/* s_draw_objs.cpp */
int s_polygon(struct s_data *q,struct Centlist *centlist,
	      int fflag,int ecol,int fcol,int show);
int s_draw_convex(struct s_data *q,struct Pathlist *list,int fflag,
		  int ecol,int col,int show);
int sgeo(struct s_data *q,complex a,complex b,int col,int show);
int s_circle(struct s_data *q,complex ctr,double r,int cflag,
	     int ccol,int col,int show);
int equator(struct s_data *q);

/* s_post_objs.cpp */
int post_s_tri(FILE *fp,complex p1,complex p2,complex p3,
	       int fflag,int ecol,int col);
int post_s_convex(FILE *fp,struct Pathlist *slist,
		  int eflag,int ecol,int col);
int post_s_geo(FILE *fp,struct s_data *screen,complex z1,complex z2);
int post_s_cir(FILE *fp,double rad,complex ctr,int cflag,
	       int ccol,int col,int numplot);
int post_equator(FILE *fp,struct s_data *q);

/* h_draw_objs.cpp */
int h_polygon(struct s_data *q,struct Centlist *centlist,
	      int fflag,int ecol,int fcol,int show);
int hgeo(struct s_data *q,complex a,complex b,int col,int show);

/* eucl drawing routines in e_draw_objs.cpp */
int kline(struct s_data *q,complex end1,complex end2,int col,int show);
int e_polygon(struct s_data *q,struct Centlist *centlist,
	      int fflag,int ecol,int fcol,int show);

/* draw_text_stuff.cpp  routines for labels, etc. */
int draw_node_labels(struct p_data *p,int show);
int draw_cir_number(struct p_data *p,int v,int n,int show);
int write_at_pt(struct p_data *p,complex pt,char *datastr,int show);
int draw_face_labels(struct p_data *p,int show);
int draw_face_number(struct p_data *p,int face,int n,int show);
int shownumber(struct s_data *q,int n,complex pt,int show);

/* post_text_stuff.cpp */
int post_cir_label(FILE *fp,struct p_data *p,int v);
int post_caption(FILE *fp,char *datastr);
int post_face_label(FILE *fp,struct p_data *p,int face);
int post_num(FILE *fp,complex pt,int n,Box box);

/* draw_circle_stuff.cpp */
int draw_any_circle(struct p_data *p,int n,int cflag,
		    int ccol,int col,int show);
int draw_any_circle_data(struct s_data *q,int hes,double r,complex ctr,
			 int cflag,int ccol,int col,int label,int show);
int draw_any_dot(struct p_data *p,int v,double diam,int cf,
		 int shape_flag,int show);
int draw_circles(struct p_data *p,int cflag,int show);
int circle(struct s_data *q,complex ctr,double r,int cflag,
	   int ccol,int col,int show);
int polyarc(struct s_data *q,double rad,complex ctr,double a1,double a2);
int unitcircle(struct s_data *q);

/* post_circle_stuff.cpp */
int post_any_circle(FILE *fp,struct p_data *p,int vert,
		    int cflag,int ccol,int col);
int post_any_circle_data(FILE *fp,struct s_data *q,int hes,double r,
			 complex ctr,int cflag,int ccol,int col,int label);
int post_cir(FILE *fp,double rad,complex ctr,
	     int cflag,int ccol,int col);
int post_any_dot(FILE *fp,struct p_data *p,int v,double diam,
		 int cflag,int shape_flag);


/* draw_face_stuff.cpp   drawing edges, faces, complex, bdry, etc */
int layout_draw_facelist(struct p_data *p,int fflag,
			 struct Vertlist **facelist,
			 int fix,int l_face,int show);
int draw_complex(struct p_data *p,int fflag,int show);
int draw_edge_points(struct s_data *q,int hes,complex v_cent,
		     complex w_cent,int col,int show);
int draw_edge(struct p_data *p,int v1,int v2,int col,int show);
int draw_bdry_seg(struct p_data *p,int n,int eflag,int ecol);
int draw_bdry_seg_num(struct p_data *p,int n);
int draw_any_face(struct p_data *p,int face,int fflag,
	      int ecol,int fcol,int show);

/* post_face_stuff.cpp */
int post_facelist(FILE *fp,struct p_data *p,int fflag,
		  struct Vertlist **facelist,int fix,int l_face);
int post_bdry_seg(FILE *fp,struct p_data *p,int n,int eflag,int ecol);
int post_bdry_seg_num(FILE *fp,struct p_data *p,int n);
int post_any_face(FILE *fp,struct p_data *p,int face,
		  int fflag,int ecol,int col);

/* post_ops_stuff.cpp  opening/managing/closing postscript files */
int open_psfile(struct p_data *p,int flag,char *datastr,
		FILE **FP,char *filename,char *user_name,char *Message);
int close_psfile(FILE **FP);
int begin_page_info(FILE *fp,struct p_data *p,int n);
int position_after(FILE *fp,char *datastr);
int position_before(FILE *fp,char *datastr);
int post_size_settings(FILE *fp,struct p_data *p,int flag);
int custom_trailer(FILE *fp,int flag);

/* mobius_math.cpp */
Mobius ident_mob();
complex tsqr_mob(Mobius M);
Mobius emap_mob(complex z1,complex z2,complex w1,complex w2);
int matrix_conj(Mobius *M);
int matrix_transpose(Mobius *M);
Mobius matrix_product(Mobius A,Mobius B);
complex det(Mobius M);
Mobius inv_mob(Mobius M);
Mobius trans_abAB(complex a,complex b,complex A,complex B,
		  complex c,complex C,int *err_flag);
Mobius auto_abAB(complex a,complex b,complex A,complex B,
		 double *err,int *err_flag);
Mobius standard_mob(complex a,complex b,int *err_flag);
Mobius norm_abc(complex a,complex b,complex c,int *e_flag);
Mobius affine_mob(complex a,complex b,complex A,complex B,int *err_flag);
Mobius recip_mob();
int set_reflection(Mobius *M,complex ctr,double r);
Mobius cir_invert(complex ctr1,double CPrad1,complex ctr2,double CPrad2,int *err_flag);
complex mobius(Mobius M,complex z,int flag);
complex mob_trans(complex z,complex a);
complex mob_rotate(complex z,double a);
complex mob_norm_inv(complex w,complex a,complex b);
complex mob_norm(complex z,complex a,complex b);
Mobius mult_mobius(Mobius M,Mobius C,int flag);
int mobius_of_circle(Mobius Mob,int hes,complex z,double r,
		     complex *newz,double *newr,int flag);
int mobius_fixed_pts(Mobius mob,complex *z1,complex *z2,int *inf_flag,
		     double *angle,double *length);

/*  alloc_stuff.cpp */
struct p_data *init_packing();
int alloc_pack_space(struct p_data *p,int new_size,int flag);
int alloc_faces_space(struct p_data *p);
int alloc_overlaps(struct p_data *p);
int alloc_edge_pair(struct p_data *p);

/* free_stuff.cpp */
int tok_free(StrTok **strTok,int n);
int vert_free(struct Vertlist **vertlist);
int cent_free(struct Centlist **centlist);
int path_free(struct Pathlist **pathlist);
int edge_free(struct Edgelist **edgelist);
int free_redfaces(struct RedList **redlist);
int free_bdrydata(struct BdryData **bdrydata);
int free_overlaps(struct p_data *p);
int free_p_data(struct p_data **pack);
int free_p_light(struct p_light **plight);

/* grab_stuff.cpp */
int grab_next(char **ptr,char *next);
int grab_line(char *targ,char **sour,int n);
int stripsp(char *datastr);
int notspace(char *ptr);
char *after_char(char *datastr,char *target);

/* comp_dilatation */
int face_dilatation(struct p_data *p,struct p_data *q,
		    int face,double *retval);

/* energy_comp_stuff.cpp */
int print_energy(struct p_data *p);
double comp_energy(struct p_data *p,double s);
double comp_min_dist(struct p_data *p);

/* generation_stuff.cpp */
int *label_generations(struct p_data *p,int max,int *last_vert,int *count);
int *label_seed_generations(struct p_data *p,int seed,int *vec_seed,
			    int max,int *far_vert,int *count);

/* geom_to_convert_stuff.cpp */
int geom_to_e_pack_convert(struct p_data *p);
int geom_to_h_pack_convert(struct p_data *p);
int geom_to_s_pack_convert(struct p_data *p);
int geom_to_h_call(struct p_data *p,char *datastr);
int geom_to_e_call(struct p_data *p,char *datastr);
int geom_to_s_call(struct p_data *p,char *datastr);

/* pt_in_object_stuff.cpp */
struct Vertlist *cir_search(struct p_data *p,complex z);
int pt_in_cir(struct p_data *p,int n,complex z);
struct Vertlist *tri_search(struct p_data *p,complex z);
int pt_in_tri(struct p_data *p,int n,complex z);
double row_col(double x,double y,double xa,double xb,double ya,double yb);


/* set_abc_stuff.cpp */
int choose_alpha(struct p_data *p);
int choose_beta(struct p_data *p);
int choose_gamma(struct p_data *p);
int set_alpha(struct p_data *p,int i);
int set_beta(struct p_data *p,int i);
int set_gamma(struct p_data *p,int i);

/* set_aim_stuff.cpp */
int set_aim_current(struct p_data *p,int flag);
int set_aim_default(struct p_data *p);
int set_aims(struct p_data *p,char *datastr);

/* set_poison_stuff.cpp */
int outer_poison(struct p_data *p,struct Vertlist *facelist);
int set_poison(struct p_data *p,char *datastr);
int poison_patch(struct p_data *p,int seed,char *datastr);


/* cookie_stuff.cpp */
int cookie_cutter(struct p_data *p,char *datastr,int **newold);
int rationalize_subcomplex(struct p_data *p,int seed,
			   struct RedList *redlist,
			   struct Vertlist *fdo,int **newold);
int zero_duty_flags(struct BdryData *bdrydata);

#ifndef __RIFFLE_PROT__
#define __RIFFLE_PROT__
int e_riffle(struct p_data *p,int passes, 
	     int passNo = PASS_FIRST | PASS_MIDDLE | PASS_LAST, 
	     double *cutp = NULL, void **state = NULL);
int old_e_riffle(struct p_data *p,int passes, 
		 int passNo = PASS_FIRST | PASS_MIDDLE | PASS_LAST, 
		 double *cutp = NULL, void **state = NULL);
int new_e_riffle(struct p_data *p,int passes, 
		 int passNo = PASS_FIRST | PASS_MIDDLE | PASS_LAST, 
		 double *cutp = NULL, void **state = NULL);
int e_riffle_O3(struct p_data *p,int passes, 
		int passNo = PASS_FIRST | PASS_MIDDLE | PASS_LAST, 
		double *cutp = NULL, void **state = NULL);
int e_riffle_vert(struct p_data *p,int i);

/* h_riffle_stuff.cpp */
int h_riffle(struct p_data *p,int passes, 
	     int passNo = PASS_FIRST | PASS_MIDDLE | PASS_LAST, 
	     double *cutp = NULL, void **state = NULL);
int x_riffle(struct p_data *p,int passes, 
	     int passNo = PASS_FIRST | PASS_MIDDLE | PASS_LAST, 
	     double *cutp = NULL, void **state = NULL);
int h_riffle_O3(struct p_data *p,int passes, 
		int passNo = PASS_FIRST | PASS_MIDDLE | PASS_LAST, 
		double *cutp = NULL, void **state = NULL);
int new_h_riffle(struct p_data *p,int passes, 
		 int passNo = PASS_FIRST | PASS_MIDDLE | PASS_LAST, 
		 double *cutp = NULL, void **state = NULL);
int old_h_riffle(struct p_data *p,int passes, 
		 int passNo = PASS_FIRST | PASS_MIDDLE | PASS_LAST, 
		 double *cutp = NULL, void **state = NULL);
int h_riffle_vert(struct p_data *p,int i);

/* s_riffle_stuff.cpp */
int s_riffle(struct p_data *p,int passes, 
	     int passNo = PASS_FIRST | PASS_MIDDLE | PASS_LAST, 
	     double *cutp = NULL, void **state = NULL);
int s_riffle_vert(struct p_data *p,int i);
#endif

/* catalog_stuff.cpp */
int catalog_faces(struct p_data *p);
int destroy_catalog();

/* comb_util_stuff.cpp */
int nghb(struct p_data *p,int v,int w);
int abutting_face(struct p_data *p,int v,int w);
int find_index(struct p_data *p,int f,int v);
int nghb_tri(struct p_data *p,int m,int n);
int red_share_vert(struct p_data *p,struct RedList *redlist);
int check_face(struct p_data *p,int f,int v,int w);
int what_face(struct p_data *p,int a,int b,int c);
int cross_edge_vert(struct p_data *p,int v,int k);
int left_face(struct p_data *p,int v,int w,int *u);
int index_of_paired_edge(struct p_data *p,int n);
int hex_proj(struct p_data *p,int v,int w);
int hex_extend(struct p_data *p,int v,int w,int lgth);
int bdry_comp_count(struct p_data *p,int v);
int verts_share_bdry(struct p_data *p,int v1,int v2);
int red_fan(struct p_data *p,struct RedList *redlist,int v,int *n1,int *n);
int common_nghbs(struct p_data *p,int v,int w);
struct RedList *back_thru_blue(struct p_data *p,struct RedList *spot);

/* consume_stuff.cpp */
int consume_one_index(struct Vertlist **vptr);
int consume_one_edge(struct Edgelist **eptr,int *v1,int *v2);

/* debug_stuff.cpp */
int double_to_err(double d);
int showhandle(struct RedList *handle);
int showlist(struct Vertlist *vertlist);
int pfacered(struct p_data *p);
int print_redfaces(struct p_data *p,struct RedList *redfaces);
int print_flower(struct K_data *K,int v);
int pack_to_stderr(struct p_data *p);
int pack_face_draw_order(struct p_data *p);
int face_debug(struct p_data *p);
int list_non_plots(struct p_data *p);
int red_bug(struct p_data *p,struct RedList *redfaces);
int print_one_redface(FILE *fd,struct p_data *p,struct RedList *redface);
int print_redface(FILE *fd,struct RedList *redface);
int lightverts_q(struct p_light *pl);
int vertlist_q(struct p_data *p,struct Vertlist *vertlist);
int list_q(struct p_data *p,int *list);
int util_q(struct p_data *p);
int colorlist_q(struct p_data *p,int *list);
int redlist_q(struct p_data *p,struct RedList *redlist);
int record_redlist(struct RedList *redlist,int lim);
int record_bdrydata(struct p_data *p,struct BdryData *bdrydata,int **face_org);
int pford(struct p_data *p);
int ck_list(struct RedList *redlist);
int record_edge_pair(struct p_data *p);
int record_face_verts(struct p_data *p);
int print_pathlist(struct Pathlist *pathlist);

/* delete_vert_stuff.cpp */
int delete_vert(struct p_data *p,int v);
int puncture(struct p_data *p,int v);
int remove_bdry_vert(struct p_data *p,int v);
int remove_tri_vert(struct p_data *p,int v);
int remove_quad_vert(struct p_data *p,char *datastr);
int remove_circle(struct p_data *p,char *datastr);
int puncture_call(struct p_data *p,char *datastr);

/* redchain_stuff.cpp */
struct RedList *build_redchain(struct p_data *p,int seed,
			       struct Vertlist *fdo);
struct RedList *back_red_face(struct p_data *p,struct RedList *spot,int vert);
struct RedList *find_seg_start(struct p_data *p,struct RedList *spot_ptr,
		   int indx,int *start_indx,int *vert,int *flag);
struct RedList *find_paired_start(struct p_data *p,struct RedList *start_ptr,
				  int indx,int *end_indx);
struct RedList *next_red_edge(struct p_data *p,int dir,
		struct RedList *spot_ptr,int indx,int *new_indx);
int loop_vert(struct p_data *p,struct RedList **redlist,
	      struct Vertlist **fdo,struct RedList **stop_ptr,
	      int *tripflag,int mode,int *hit);
int redface_comb_info(struct p_data *p,struct RedList *redlist,
		      struct EdgePair *edge_pair);
int add_face_to_redlist(struct p_data *p,int f,struct RedList **redptr);
int query_in_red(struct RedList *redlist,int face);
int add_face_order(struct p_data *p,struct Vertlist **fdo,
		   int face,int preface);

/* face_order_stuff.cpp */
int facedraworder(struct p_data *p,int pflag);
int final_order(struct p_data *p,struct Vertlist **fdo,
		int *lastface,struct RedList *redlist);
int wrapup_order(struct p_data *p,int lastface);
int position_redlist(struct RedList **redlist,int face);
int nice_index(struct p_data *p,int f,int index);

/* blend_stuff.cpp */
int match(struct p_data *p,struct p_data *q,int v1,int v2,
	  int w1,int w2,double *err,int *err_flag,Mobius *M);
int comb_bdry_antip(struct p_data *p,int *v,int *w);
int blend(struct p_data *p,struct p_data *q,int bdry_vert,int depth);
int CPgzreopen(FILE *fp, char *mode);

/* file_search_stuff.cpp */
long find_token(FILE *fp,long pos,char **string,char *token);
int find_name(FILE *fp,char *name,long *pos);

/* sa_draw_circle_stuff.cpp */
int sa_draw_circle(struct p_data *p,int n,
		   int cflag,int ccol,int col,int show);
int sa_draw_circle_data(int pnum,double r,complex ctr,
			int cflag,int ccol,int col,int label,int show);
int sa_draw_circlepack(struct p_data *p,int cflag);


/* sa_draw_face_stuff.cpp */
int sa_layout_facelist(struct p_data *p,int fflag,struct Vertlist **facelist,
		       int fix,int l_face,int show);
int sa_draw_complex(struct p_data *p,int fflag);
int sa_draw_edge_points(int pnum,complex v_cent,complex w_cent,int col);
int sa_draw_edge(struct p_data *p,int v1,int v2,int col);
int sa_draw_bdry_seg(struct p_data *p,int n,int eflag,int ecol);
int sa_draw_bdry_seg_num(struct p_data *p,int n);
int sa_draw_face(struct p_data *p,int face,int fflag,
		 int ecol,int fcol,int show);
int sa_draw_face_data(int pnum,complex ctr[],int face,
		      int fflag,int ecol,int fcol,int show);
int sa_draw_path(struct p_data *p,struct Pathlist *pathlist,int length); 

/* sa_write_at_pt.cpp */
int sa_write_at_pt(complex pt,char *datastr);
int disp_label(complex ctr,char *datastr,int msg_flag,int show);
int display_token(complex z,int tok,int colr,int show);
int disp_label(complex ctr,char *datastr,int msg_flag,int show);

/* sa_screen.cpp */
int sa_display_call(struct p_data *p,char *datastr);
int sa_disp_screen(struct p_data *p,int cflag,int fflag);
int sa_coord_axes(struct p_data *p);
int sa_draw_in_order(struct p_data *p,int cflag,int fflag,int pl);

/* sa_XML.cpp */
int canvas_mode_defaults(struct p_data *p);
int coord_axes_mode(struct p_data *p,int flag);
int line_thick_mode(struct p_data *p,int t);
int unitcircle_mode(struct p_data *p,int set);
int equator_mode(struct p_data *p,int set);
int sa_set_cursor_mode(struct p_data *p,int m,int flag);
int send_box_info(struct p_data *p,int flag);
int send_sph_view(struct p_data *p);
int sa_send_geom(struct p_data *p);
int set_pack_label(struct p_data *p);
int repack_activity_msg(char *datastr);
int sa_clear_canvas(struct p_data *p,int flag);
int sa_window_bell();
int labellist(struct p_data *p,struct Vertlist *list,int msg_flag,
	      int faces);
complex face_center(struct p_data *p,int face);
int send_unit_circ(struct p_data *p,int flag);
int sa_refresh_canvas(struct p_data *p);
int msg();
int emsg();
int smsg();
int quit(int flag);
int chg_active_pack(int pnum);
int openMap_call(struct p_data *p,struct p_data *q);
int closeMap_call();

/* sa_io.cpp */

int writecall(struct p_data *p,char *filename,int act);
int stat_file(char *filename);
int read_infile(struct p_data *p,char *datastr);
int readcall(struct p_data *p,char *filename);
int seed_start_call(struct p_data *p,char *datastr);

/* sa_call.cpp */

int compress_call(char *datastr);
int read_packrc(char *filename);
int pack_num(struct p_data *p);
int add_circles_call(struct p_data *p,char *datastr);
int add_ideal_call(struct p_data *p,char *datastr);
int cir_invert_call(struct p_data *p,char *datastr);
int cookie_call(struct p_data *p,char *datastr);
int enfoldcall(struct p_data *p,char *datastr);
int gen_cut_call(struct p_data *p,char *datastr);
int gen_islands_call(struct p_data *p,char *datastr);
int hex_parallel_call(struct p_data *p,int v,int w,int n,complex *cmod,
		      int show);
int j_ftn_call(struct p_data *p,char *datastr);
int mend_call(struct p_data *p,char *datastr,int totalpasses);
int plug_call(struct p_data *p,char *datastr);
int molify_call(struct p_data *p,char *datastr);
int reverse_orient_call(struct p_data *p);
int proj_max_to_s(struct p_data *p,char *datastr);
int NSpole(struct p_data *p,char *datastr);
int riffle_call(struct p_data *p,int passes,int lpr,int flag);
int norm_scale_call(struct p_data *p,char *datastr);
int set_aim_call(struct p_data *p,char *datastr);
int randize(struct p_data *p,char *datastr);
int set_overlapscall(struct p_data *p,char *datastr);
int slit_complex_call(struct p_data *p,char *datastr);
int embed_call(struct p_data *p,char *datastr);
int embedding(struct p_data *p1, struct p_data *p2,int a,int b,
	      int A,int B,struct Edgelist **matches);

/* sa_cmd.cpp */

int parse_cmd(struct p_data *p,int *hflag,int *targ_p);

/* sa_special.cpp */

int special1(char *datastr);
int special2(char *datastr);
int special3(char *datastr);
int special4(char *datastr);
int special5(char *datastr);
int special6(char *datastr);
int special7(char *datastr);
int special8(char *datastr);
int special9(char *datastr);
int special10(char *datastr);

/* bio.cpp */
IOBUF *bdopen(int d, const char *mode);
IOBUF *bsopen(int d, const char *mode);
int bclose(IOBUF *stream);
int bprintf(IOBUF *stream, const char *format, ...);
int bflush(IOBUF *stream);
char *bgets(char *s, int size, IOBUF *stream);

/* CPdtos.cpp */

char *CPdtos(double d, char *buf, int prec, int fmtch);
double CPstod(char *buf);
int CPgetd(FILE *stream, double *d);
int CPputd(FILE *stream, double d, int prec, int fmtch);

/* output_call.cpp */

int output_parse(struct p_data *p,FILE *fp,char *datastr,Mobius mob);
char *find_literal(char *datastr,char **endptr,int qflag);
int data_obj_parse(char *datastr,int *code);
int print_vert_obj(struct p_data *p,FILE *fp,int code,int v);
int print_face_obj(struct p_data *p,FILE *fp,int code,int f);
int print_edge_obj(struct p_data *p,FILE *fp,int code,int v,int w);
int output_call(struct p_data *p,char *datastr);

/* encircle.cpp */
struct Edgelist *encircle(struct p_data *p,struct Vertlist *vertlist,
			  int init_v, int *hits,int opt);
int nghb_blob_count(int v);
int triple_blob(int v);
int reverse_blob(int v,int indx);
struct Edgelist *encircle_call(struct p_data *p,char *datastr);

/* path_elist.cpp */
struct Edgelist *path_to_elist(struct p_data *p,struct Pathlist *path);
struct Pathlist *elist_to_path(struct p_data *p,
			       struct Edgelist *e_list,int *len);

/* misc */
int ps_to_jpg(const char *filename, int quality);
int ps_to_gif(const char *filename);
int separate_p_light_components(struct p_light *pl,
       struct p_light ***componentList);
void mark_all_neighbors_recursive(int cell,
       struct p_light *pl, int *visited, int compNo);

int alt_rect_pack(struct p_data *p,char *datastr);
int add_bearings(struct p_data *p,int *startv,int *endv);
struct p_data *skeleton(struct p_data *p,struct Vertlist *vlist);
int skeleton_call(struct p_data *p,char *datastr);
int count_call(struct p_data *p,char *datastr);
int graph_popup(double *xdata,double *ydata,int N,char *datastr,int show);

double any_edge_length(struct p_data *p,struct Edgelist *elist);
int criterion(complex z);
void set_random_seed();

StrTok *string_tokenizer(char *datastr,int *allocation,int *N);
int tok_is_flag(StrTok tok,char c);
char *flag_to_flag(StrTok *token,int start,int end);
StrTok *grab_filename(StrTok *strtok,int *inflag);
char *reconstitute(StrTok *strtok);
