#include "sa_types.h"
#include "sa_proto.h"

/* inc/dec radii of the string. 
For x_radii, replace x by x=1-exp(factor*(log(1-x))). 
For eucl radii, just multiply.  Return 0 on error. */

int adjust_radii(struct p_data *p,char *datastr)
{ 
  char *endptr,*nextpoint;
  int count=0,vert,hits;
  double factor,newrad;
  struct Vertlist *vertlist=NULL,*trace;
  struct R_data *pR_ptr=p->packR_ptr;

  nextpoint=datastr;
	if (!grab_next(&nextpoint,next) || sscanf(next,"%lf",&factor)!=1 
		|| factor<=0.001 || fabs(factor-1.0)<.00001) 
  		return 0;
	endptr=nextpoint;
  	if (!grab_next(&endptr,next)) {
  		strcpy(next,"a");
		vertlist=Node_link_parse(p,next,&endptr,&hits,
			&Vlist,&Elist,&Flist,&region,pathlist,pathlength);
  	}
  	else vertlist=Node_link_parse(p,nextpoint,&endptr,&hits,
		&Vlist,&Elist,&Flist,&region,pathlist,pathlength);
	if (vertlist==NULL) return 0;

    trace=vertlist;
    if (p->hes<0) {
    	do {
	    vert=trace->v;
	    if (pR_ptr[vert].rad<=0) {
	    	if (factor < 1.0) { /* horocycle? */ 
		      newrad=.99995; /* make finite: roughly h=5 */
		      count += h_changerad(p,vert,newrad);
		    }
		    // ignore if factor>1.0, since radius is already infinite
	    }
	    else {
			newrad=1.0-exp(factor*log(1.0-pR_ptr[vert].rad));
			count += h_changerad(p,vert,newrad);
	    }
	    trace=trace->next;
	    } while (trace!=NULL);
    }
	else if (p->hes>=0) {
		do {
	    vert=trace->v;
	    newrad=factor*pR_ptr[vert].rad;
	    if (p->hes>0)
	      count += s_changerad(p,vert,newrad);
	    else
	      count += e_changerad(p,vert,newrad);
	    trace=trace->next;
		} while (trace!=NULL);
	}
	
    vert_free(&vertlist);
  	if (count) {
      fillcurves(p);
      return count;
    }
  strcpy(msgbuf,"No radii adjusted.");
  emsg();
  return 0;
} /* crement_radii */



