#include "sa_types.h"
#include "sa_proto.h"

/* Return 'aspects' of up to 8 euclidean circles.
Return count, or 0 on error. */

int aspect(struct p_data *p,char *datastr)
{
  int v,hits,count=0;
  double modz;
  char *endptr;
  struct Vertlist *vertlist=NULL,*trace;
  struct R_data *pR_ptr=p->packR_ptr;

  if (!p->status || p->hes
      || !(vertlist=Node_link_parse(p,datastr,&endptr,&hits,
		&Vlist,&Elist,&Flist,&region,pathlist,pathlength))) 
    return 0;
  trace=vertlist;
  sprintf(msgbuf,"Aspects: \n");
  msg();
  while (trace && count < 8) {
    modz=cAbs(pR_ptr[(v=trace->v)].center);
    if (modz<okerr)
      sprintf(msgbuf,"v=%d: at origin.  ",v);
    else 
      sprintf(msgbuf,"v=%d: %lf  ",v,(singledouble)(pR_ptr[v].rad/modz));
    if (count>0 && !(count%2)) strcat(msgbuf,"\n");
    msg();
    count++;
    trace=trace->next;
  }
  vert_free(&vertlist);
  return count;
} /* aspect */
   
