#include "sa_types.h"
#include "sa_proto.h"

int count_call(struct p_data *p,char *datastr)
     /* count number of verts/edges/faces in list. Return 0 on error. */
{
  int i,count=0,hits,*util;
  char *nextpoint,*endptr;
  struct Vertlist *trace,*vlist=NULL;
  struct Edgelist *etrace,*edgelist=NULL;
  struct K_data *pK_ptr=p->packK_ptr;

  if (*datastr!='-' || strlen(datastr)<4) return 0;
  nextpoint=datastr+2;
  switch(datastr[1])
    {
    case 'c': /* circles */
    case 'v': /* vertices */
      {
	if (!(vlist=Node_link_parse(p,nextpoint,&endptr,&hits,
              &Vlist,&Elist,&Flist,&region,pathlist,pathlength)))
	  {
	    sprintf(msgbuf,"count: no vertices specified");
	    msg();
	    return 0;
	  }
	for (i=1;i<=p->nodecount;i++) pK_ptr[i].util_flag=0;
	trace=vlist;
	while (trace && !pK_ptr[trace->v].util_flag) 
	  {
	    count++;
	    pK_ptr[trace->v].util_flag=1;
	    trace=trace->next;
	  }
	vert_free(&vlist);
	sprintf(msgbuf,"count: vertices %d.",count);
	msg();
	return count;
	break;
      }
    case 'f': /* faces */
      {
	if (!(vlist=Face_link_parse(p,nextpoint,&endptr,&hits,
	      &Vlist,&Elist,&Flist,&region,pathlist,pathlength)))
	  {
	    sprintf(msgbuf,"count: no faces specified");
	    msg();
	    return 0;
	  }
	util=(int *)calloc((size_t)(p->facecount+1),sizeof(int));
	trace=vlist;
	while (trace && !util[trace->v]) 
	  {
	    count++;
	    util[trace->v]=1;
	    trace=trace->next;
	  }
	vert_free(&vlist);
	free(util);
	sprintf(msgbuf,"count: faces %d.",count);
	msg();
	return count;
	break;
      }
    case 'e': /* edges: note I don't check for redundancies here */
      {
	if (!(edgelist=Node_pair_link(p,nextpoint,&endptr,&hits,
	      &Vlist,&Elist,&Flist,&region,pathlist,pathlength)))
	  {
	    sprintf(msgbuf,"count: no edges specified");
	    msg();
	    return 0;
	  }
	etrace=edgelist;
	while (etrace) 
	  {
	    count++;
	    etrace=etrace->next;
	  }
	edge_free(&edgelist);
	sprintf(msgbuf,"count: edges %d.",count);
	msg();
	return count;
	break;
      }
    case 'b': // boundary starts
      {
      	return p->num_bdry_comp;
      	break;
      }
    } /* end of switch */
  return 1;
} /* count_call */
