#include "sa_types.h"
#include "sa_proto.h"

/* comp angle sum c and its derivative d (with respect to the 
s_radius, for interior nodes in hyp setting. Deriv depends on 
whether some of radii are infinite */

int h_curvcalc(struct p_data *p,int i,double x,double *c,double *d)
     /* assuming incoming radii are x not s; TRUE or NOT? should fixup. */
{
  int k,dum=0;
  double s,s1,s2,x1,x2,a,b,cc,e,ss,cs;
  struct K_data *pK_ptr=p->packK_ptr;
  struct R_data *pR_ptr=p->packR_ptr;

  *c=0;*d=0;
  if (x<=0) return 1; /* infinite radius at vertex of interest */
  s = x_to_s_rad(x);
  x2 = pR_ptr[pK_ptr[i].flower[0]].rad;
  s2 = x_to_s_rad(x2);
  for (k=1;k<=pK_ptr[i].num;k++)
    {
      s1=s2;
      x1=x2;
      x2=pR_ptr[pK_ptr[i].flower[k]].rad;
      s2=x_to_s_rad(x2);
      cs=h_comp_x_cos(x,x1,x2);
      *c+=acos(cs);
      if ((x1>0) && (x2>0))
	{
	  cc=(-2+x1+x2);
	  b=(1-x1)*(1-x2);
	  e=2*x1*x2;
	  a=cc-e;
	  ss=(1-x);
	  *d+=2*e*(1-b*ss*ss)/((1+cc*ss+b*ss*ss)*
			       sqrt( e*(2+(cc+a)*ss+2*b*ss*ss) ));
	}
      else if ((x1<=0) && (x2<=0)) *d+=2/sqrt(x);
      else if (x1<=0) *d+=sqrt(s2/s)/(1+s2*s);
      else *d+=sqrt(s1/s)/(1+s1*s);
    }
  return 1;
} /*h_curvcalc */
