#include "sa_types.h"
#include "sa_proto.h"

/* Check "legality" of contiguous triangles, vis-a-vis Delauney
criterion. Successive four radii, R1 and R3 at ends of shared
edge, R2 and R4 opposite. Triangle is "illegal" if circle
through v1, v3, and v2 (resp. v4), contains v4 (resp. v2).
Only works in euclidean case for now. 

Return 1 for legal, 0 for illegal. */

int legal_check(double R1,double R2,double R3,double R4)
{
  double a=R1+R2;
  double b=R2+R3;
  double c=R3+R4;
  double d=R4+R1;
  double e=R1+R3;

  double t1=(a*a+e*e-b*b)/(2.0*a*e);
  double t2=(d*d+e*e-c*c)/(2.0*d*e);
  return 0;
  
} /* legal_check */
