#include "sa_types.h"
#include "sa_proto.h"

int new_readpath(std::ifstream &infile,struct Pathlist **pathlist,int *pathlength)
{
  int count=0;
  double xx,yy;
  char command[50];
  struct Pathlist *trace;
  
  if (infile.eof() || infile.fail()) return 0;
  while(!infile.eof())  {
      infile >> command;  // Extracting a string from a stream gets one
                          // word at a time.
      if(infile.fail())  break;  // We can't detect input failure
                                 // until the >> operator returns.
      if(strcmp(command, "END") == 0)  break;
      if(strcmp(command, "PATH") == 0)  break;
  }
  infile >> xx >> yy;
  if (strcmp(command,"END")==0 || infile.fail() || infile.eof())
    return 0; // no points

  *pathlength=0;
  if ( ((*pathlist)=(struct Pathlist *)calloc(1,sizeof(struct Pathlist)))
       !=NULL ) 
    {
      (*pathlist)->x=xx;(*pathlist)->y=yy;
      count++;
    }
  else return 0; 
  trace=(*pathlist);
  while 
    (!(infile.eof()) &&  count<2000
      && ((trace->next=(struct Pathlist *)calloc(1,sizeof
                                                 (struct Pathlist)))!=NULL ) )
    {
      infile >> xx >> yy;
      if(infile.fail())  break;
      trace=trace->next;
      trace->x=xx;trace->y=yy;
      count++;
    }
  if (count<3)  // didn't get enough points
    {path_free(pathlist); *pathlist=NULL;*pathlength=0;return 0;} 
  trace=(*pathlist);
  while (trace->next!=NULL) trace=trace->next;
  if (trace->x!=(*pathlist)->x || trace->y!=(*pathlist)->y)
    {
      trace->next=(struct Pathlist *)calloc
        (1,sizeof(struct Pathlist));
      trace->next->x=(*pathlist)->x;
      trace->next->y=(*pathlist)->y;
      count++;
    } // make sure path closes up
  *pathlength=count;
  return count;
} /* readpath */

// Other useful input functions not shown above:
//
// char ch;
// int len = 256;
// char buf[len];
//
// infile.get(ch);            // Like ch = getc(infile);
// infile.read(buf, len);     // Like fread()
// infile.getline(buf, len);  // Like fgets()

