#include "sa_types.h"
#include "sa_proto.h"

/* Put a definition of 'mark' in the postscript file. It will then be
used when the 'd' option in print_call is called. Currently: d=dot, 
x=cross. */

int post_shape(FILE *fp,char symb)
{
  if (symb=='d') /* round filled dot */
    fprintf(fp,"/mark  {gs 0 360 a srgb fill gr} def\n");
  else if (symb=='c') /* round open dot */
    fprintf(fp,"/mark  {gs 0 360 a srgb s gr} def\n");
  else if (symb=='x') /* cross */
    {
      fprintf(fp,"/mark  {gs n 3 1 roll moveto dup sc\n");
      fprintf(fp,".25 0 rm .75 .75 rlineto -.25 .25 rlineto "
	      "-.75 -.75 rlineto -.75 .75 rlineto -.25 -.25 rlineto "
	      ".75 -.75 rlineto -.75 -.75 rlineto .25 -.25 rlineto "
	      ".75 .75 rlineto .75 -.75 rlineto .25 .25 rlineto "
	      "-.75 .75 rlineto cp srgb fill s gr} def\n");
    }
  return 1;
} /* post_shape */
