#include "sa_types.h"
#include "sa_proto.h"

/*
 * ps_to_gif: does what it says by calling the UNIX shell
 * command convert. Returns 0 on success, -1 for internal 
 * errors, and the shell error code for errors in the command.
 * See ps_to_jpg.
 */

int ps_to_gif(const char *filename)
{
  int rv;
  char *newname,*lastdot,*cmdstr;
  char cmdtmpl[]="convert %s %s\n";

  char newsfx[]=".gif",oldsfx[]=".ps";

  newname=(char *)calloc((strlen(filename)+strlen(newsfx)+1),sizeof(char));
  strcpy(newname, filename);
  lastdot=strrchr(newname, '.');
  if(lastdot && strcmp(lastdot, oldsfx)==0) strcpy(lastdot,newsfx);
  else  strcat(newname,newsfx);

  fprintf(stderr, "converting %s to %s\n",filename,newname);
  
  cmdstr=(char *)
    calloc((strlen(cmdtmpl)+strlen(filename)+strlen(newname)+4),
	   sizeof(char));
  sprintf(cmdstr,cmdtmpl,filename,newname);
  rv=system(cmdstr);
  
  free(cmdstr);
  free(newname);
  
  return rv;
} /* ps_to_gif */
