#include "sa_types.h"
#include "sa_proto.h"

/* Terminal string in 'datastr' MUST be filename; preceeded by
'-f' (set_flag=0) to open/overwrite or '-a' (set_flag=1) to open/append.
Return pointer to beginning of filename, cut off datastr to truncate 
flag and filename.
(Note: formerly used '>' (open) and '>>' (append), but this
conflicted with XML.) */

char *ptr_to_name_at_end(char *datastr,int *flag)
{
  char *name_ptr,*ptr;
  
  *flag=0;
  ptr=datastr+strlen(datastr);
  /* march back through white space to get to last real character */
  while (ptr>datastr && (*ptr=='\t' || *ptr=='\n' || *ptr==' ' || *ptr=='\0'))
    ptr--;
  if (ptr==datastr) return NULL; /* no data */
  /* march backward until reaching white space or (deprecated) > */
  while (ptr>datastr 
	 && *ptr!='>' && *ptr!='\0' && *ptr!='\t' && *ptr!=' ')
    ptr--;
  if (ptr==datastr) return ptr; /* datastr has nothing but name */
  name_ptr=ptr+1;
  /* have name, back through white space until '>' or '-a' */
  while (ptr>datastr && *ptr!='>' && *ptr!='a' && (*ptr=='\t' || *ptr==' '))
    ptr--;
  if (ptr==datastr) {
    *ptr='\0';
    return name_ptr;
  }
  if (*ptr=='>') {   /* deprecated behavior */
    *ptr='\0';
    ptr--;
    if (*ptr=='>') { /* append */
      *ptr='\0';
      *flag=1;
    }
    return name_ptr;
  }
  if (*ptr=='a') {
    if (*(ptr-1)!='-') { /* false indication, leave the 'a' */
      *(ptr+1)='\0';
      return name_ptr;
    }
    *ptr='\0'; /* yes, append */
    *(ptr-1)='\0';
    *flag=1;
    return name_ptr;
  }
  *(ptr+1)='\0';
  return name_ptr;
} /* ptr_to_name_at_end */

