#include "sa_head.h"

/* ================ color stuff (eventually depends on GUI) === */

unsigned long *colors,*color; /* color table and ptr to my colors. */

/* ============= global variables for CirclePack ===================== */
/* (see cp_types.h for global variables needed by the cp library) */

IOBUF *msg_out_fp;       /* stdout or msg socket mimicking stdout */
IOBUF *disp_fp;          /* stdout or socket for exchanging display info */
IOBUF *msg_in_fp;        /* stdin or socket for stdin */

FILE *post_fp;		/* file for canvas postscript output */
FILE *custom_fp;	/* file for "custom" postscript output */
FILE *log_fp;           /* file for log in cmd mode */

struct hostent *host;    /* host on which C code is running */

char CPVersion[64];     /* CirclePack Version number */
char CPHelp[256];       /* location of help file */
char rgb_file[NAME_MAX]; /* name of file of rbg colors */
char user_name[64];     /* store for use in postscript output */
char packing_dir_name[NAME_MAX]; /* directory for packings */
char print_cmd[NAME_MAX]; /* cmd for printing */
char print_file_name[NAME_MAX]; /* printing postscript file */
char ps_viewer[NAME_MAX]; /* command to popup postscript viewer (ie. gvv) */
char ps_file_name[NAME_MAX]; /* custom postscript output */
char *home_dir;		/* store user home directory */
char *working_dir;	/* store current working directory */
char *ftn_keys[12];     /* cmd strings for ftn keys 1--10 (see packrc.txt) */
char cmd_history[BUFSIZE]; /* stores last command for reuse */
char *emsgbuf,*msgbuf;	/* error message/message buffers (overlap) */
char file_name[NAME_MAX];

int cmd_mode;           /* set if in command-line mode */
int current_p;		/* index to current screen and pack */
int totalpasses;	/* number of passes in riffle */
int cmd_search_depth;	/* prevent looping of cmd search */
int draw_speed;		/* 0 = disp screen after all objects drawn */
int live_node[NUM_PACKS]; /* last circle plotted in 'projection' mode */
int live_face[NUM_PACKS]; /* last face plotted in 'projection' mode */
int init_shmem;         /* flag: shared memory initialized? */
int list_ready;         /* 'v' pressed in canvas makes it sensitive to 
			   left or middle mouse: add vert/face to 
			   vlist/flist */

double inc_factor,eucl_factor; /* default adjustment factors */

struct Edgelist *b_flip,*r_flip; /* ptrs to edges for Whitehead moves */

Mobius Mob;		/* currently specified Mobius transform */

int first_face_global;
int first_red_face_global;
int num_bdry_comp_global;
int length_global;
char topology_global[]="";
double area_global;
double inv_dist_global;
int max_ideg_global,min_ideg_global,max_bdeg_global,min_bdeg_global;
int last_index_global=1;
