#include "sa_types.h"
#include "sa_proto.h"
#include "sa_hooks.h"
#include <unistd.h>
#include <strings.h>

int CPset_home_dir(char *home_dir_parm, int len)
{
    uid_t myuid;
    struct passwd *mypassdata;	

    myuid=getuid();
    mypassdata=getpwuid(myuid);
    strncpy(home_dir_parm, mypassdata->pw_dir, len - 1);
    home_dir_parm[len - 1] = '\0';
    return 0;
} /* CPset_home_dir */

int CPset_working_dir(char *working_dir_parm, int len)
{
    getcwd(working_dir_parm, len);
    return 0;
} /* CPset_working_dir */

int CPset_user_name(char *user_name_parm, int len)
{
    uid_t myuid;
    struct passwd *mypassdata;	

    myuid=getuid();
    mypassdata=getpwuid(myuid);
    strncpy(user_name_parm, mypassdata->pw_name, len - 1);
    user_name_parm[len - 1] = '\0';
    return 0;
} /* CPset_user_name */

int timedelay(double tm)
     /* time delay about tm seconds. */
{
  struct tms buffer;  /* for getting times */
  long starttime,elapsetime;
	
  times(&buffer);
  if (tm>0)
    {
      starttime=buffer.tms_utime;
      do
	{
	  times(&buffer);
	  elapsetime=buffer.tms_utime-starttime;
	}
      while (elapsetime< tm*12);
    }
  return 1;
} /* timedelay */

long get_time()
{
  struct rusage RU;

  getrusage(RUSAGE_SELF,&RU);
  return RU.ru_utime.tv_sec;
} /* get_time */

int CPget_max_open_files()
{
    struct rlimit rl;
    int maxNoFiles;

    bzero(&rl, sizeof(struct rlimit));
    if(getrlimit(RLIMIT_NOFILE, &rl) < 0)  return -1;
    maxNoFiles = rl.rlim_max;
    if(maxNoFiles > INTERNAL_MAX_NOFILES)  {
        rl.rlim_max = INTERNAL_MAX_NOFILES;
        rl.rlim_cur = INTERNAL_MAX_NOFILES;
        if(setrlimit(RLIMIT_NOFILE, &rl) < 0)  return -1;
        maxNoFiles = INTERNAL_MAX_NOFILES;
    }

    return maxNoFiles;
} /* CPget_max_open_files */
