#include "sa_types.h"
#include "sa_proto.h"

double radius(struct p_data *p,int v)
     /* give radius. In hyp case, converts s-rad to usual hyp rad.  */
{
  double x;

  if ( (p->hes<0) && ((x=p->packR_ptr[v].rad) > 0) ) {
    if (x>.0001) return ((-0.5)*log(1.0-x));
    else return (x*(1.0+x*(0.5+x/3))/2);
  }
  return (p->packR_ptr[v].rad);
} /* radius */

double radius_pl(struct p_light *pl,int v)
     /* same, but for p_light data */
{
  double x;

  if ((pl->counts[1]<0) && ((x=pl->radii[v]) > 0.0)) {
    if (x>.0001) return ((-0.5)*log(1.0-x));
    else return (x*(1.0+x*(0.5+x/3))/2);
  }
  return (pl->radii[v]);
} /* radius_pl */
