#include "sa_head.h"


/* For SA to send message with lists of vertices, faces, or edges. 9/05.
Info is sent to the frontend; limit of BUFSIZE to message. 
flag is 0=verts, 1=edges, 2=faces..
*/

int showlists(struct p_data *p,int flag)
{
  int count=0;
  struct Vertlist *vtrace=NULL;
  struct Edgelist *etrace=NULL;

  char *listbuf=(char *)calloc(BUFSIZE+1,sizeof(char));
  sprintf(listbuf,"canv_id=\"%d\" ",pack_num(p));
  switch(flag) {
  case 0: // vertices
    {
      strcat(listbuf,"VLIST\">\n");
      if ((vtrace=p->vlist)!=NULL) {
	while (vtrace) {
	  sprintf(buf,"%d \0",vtrace->v);
	  if ((BUFSIZE-strlen(listbuf))<(strlen(buf)+2))
	    goto LEAVE;
	  strcat(listbuf,buf);
	  count++;
	  vtrace=vtrace->next;
	}
	goto LEAVE;
      }
      break;
    }
  case 1: // edges
    {
      strcat(listbuf,"ELIST\">\n");
      if ((etrace=p->elist)!=NULL) {
	while (etrace) {
	  sprintf(buf,"%d %d \0",etrace->v,etrace->w);
	  if ((BUFSIZE-strlen(listbuf))<(strlen(buf)+2))
	    goto LEAVE;
	  strcat(listbuf,buf);
	  count++;
	  etrace=etrace->next;
	}
	goto LEAVE;
      }
      break;
    }
  case 2: // faces
    {
      strcat(listbuf,"FLIST\">\n");
      if ((vtrace=p->flist)!=NULL) {
	while (vtrace) {
	  sprintf(buf,"%d \0",vtrace->v);
	  if ((BUFSIZE-strlen(listbuf))<(strlen(buf)+2))
	    goto LEAVE;
	  strcat(listbuf,buf);
	  count++;
	  vtrace=vtrace->next;
	}
	goto LEAVE;
      }
      break;
    }
  } /* end of switch */ 
 LEAVE:
  strcat(listbuf,"\0");
  bprintf(msg_out_fp,"%s",listbuf);
  if(listbuf) free(listbuf);
  return count;
} /* showlists */
