#include "sa_types.h"
#include "sa_proto.h"

/* Interchange two vertex numbers. */

int swap_nodes(struct p_data *p,int v,int w)
  /* caution: calling routine must do complex_count, facedraworder, etc.*/
{
  int i,j,vdum=0,pet;
  struct Vertlist *vtrace;
  struct Edgelist *etrace;
  struct K_data *pK_ptr=p->packK_ptr,holdK;
  struct R_data *pR_ptr=p->packR_ptr,holdR;

  holdR=pR_ptr[v];holdK=pK_ptr[v];
  pR_ptr[v]=pR_ptr[w];pK_ptr[v]=pK_ptr[w];
  pR_ptr[w]=holdR;pK_ptr[w]=holdK;
  for (i=0;i<=pK_ptr[v].num;i++) {
    pet=pK_ptr[v].flower[i];
    if (pet==v) pet=w;
    for (j=0;j<=pK_ptr[pet].num;j++)
      if (pK_ptr[pet].flower[j]==w) 
	pK_ptr[pet].flower[j]=vdum;
  }
  for (i=0;i<=pK_ptr[w].num;i++) {
    pet=pK_ptr[w].flower[i];
    if (pet==vdum) pet=v;
    for (j=0;j<=pK_ptr[pet].num;j++)
      if (pK_ptr[pet].flower[j]==v) 
	pK_ptr[pet].flower[j]=w;
  }
  for (i=0;i<=pK_ptr[v].num;i++) {
    pet=pK_ptr[v].flower[i];
    for (j=0;j<=pK_ptr[pet].num;j++)
      if (pK_ptr[pet].flower[j]==vdum) 
	pK_ptr[pet].flower[j]=v;
  }
  if (p->active_node==v) p->active_node=w;
  else if (p->active_node==w) p->active_node=v;
  if (p->alpha==v) p->alpha=w;
  else if (p->alpha==w) p->alpha=v;
  if (p->beta==v) p->beta=w;
  else if (p->beta==w) p->beta=v;
  if (p->gamma==v) p->gamma=w;
  else if (p->gamma==w) p->gamma=v;

  /* fix up various lists */
  vert_free(&(p->flist)); /* will be invalidated by complex_count */
  /* fix up vertex_map */
  etrace=p->vertex_map;
  while (etrace) {
    if (etrace->v==v) etrace->v=w;
    else if (etrace->v==w) etrace->v=v;
    etrace=etrace->next;
  }
  etrace=p->elist;
  while (etrace) {
    if (etrace->v==v) etrace->v=w;
    else if (etrace->v==w) etrace->v=v;
    if (etrace->w==v) etrace->w=w;
    else if (etrace->w==w) etrace->w=v;
    etrace=etrace->next;
  }
  vtrace=p->vlist;
  while (vtrace) {
    if (vtrace->v==v) vtrace->v=w;
    else if (vtrace->v==w) vtrace->v=v;
    vtrace=vtrace->next;
  }
  return 1;
} /* swap_nodes */

int swap_nodes_call(struct p_data *p,char *datastr)
/* call and process. */
{
  int v,w,hits;
  char *nextpoint,*endptr;
  struct Vertlist *vlist;

  nextpoint=datastr;
  if (!(vlist=Node_link_parse(p,nextpoint,&endptr,&hits,
	&Vlist,&Elist,&Flist,&region,pathlist,pathlength))
      || !(vlist->next) || vlist->v==vlist->next->v)
    return 0;
  v=vlist->v;
  w=vlist->next->v;
  vert_free(&vlist);
  if (!swap_nodes(p,v,w)) return 0;
  complex_count(p,0);
  facedraworder(p,0);
  return 1;
} /* swap_nodes_call */
