#include "sa_types.h"
#include "sa_proto.h"

/* for hex_walk, called by hex_parallel_call and fix -h to draw 
parallelogram. Edge lengths n, start edge = v w, counterclockwise. 
Return corner verts; v2,v4 "sharp" corners. */
	
struct Vertlist *try_hex_pg(struct p_data *p,int v,int w,int n,
			    int *v1,int *v2,int *v3,int *v4)
{
     int i,num;
     struct Edgelist *edgelist;
     struct Vertlist *vertlist,*vtrace,*facelist;
     struct K_data *pK_ptr;

     pK_ptr=p->packK_ptr;
     facelist=NULL;
     if (nghb(p,v,w)<0) return facelist; /* must start with edge */
/* record first two vertices */
     *v1=v;
     vertlist=(struct Vertlist *)calloc((size_t)1,sizeof(struct Vertlist));
     vertlist->v=v;
     vtrace=vertlist->next=(struct Vertlist *)
	calloc((size_t)1,sizeof(struct Vertlist));
     vtrace->v=w;
/* first edge */
     for (i=2;i<=n;i++) 
      {
          vtrace=vtrace->next=(struct Vertlist *)
	    calloc((size_t)1,sizeof(struct Vertlist));
          num=pK_ptr[w].num;
          vtrace->v=pK_ptr[w].flower[(nghb(p,w,v)+num-3) % num];
          v=w;
          w=vtrace->v;
      }
/* sharp left turn */
     *v2=w;
     vtrace=vtrace->next=(struct Vertlist *)
	calloc((size_t)1,sizeof(struct Vertlist));
     num=pK_ptr[w].num;
     vtrace->v=pK_ptr[w].flower[(nghb(p,w,v)+num-1) % num];
     v=w;
     w=vtrace->v;
/* second edge */
     for (i=2;i<=n;i++) 
      {
          vtrace=vtrace->next=(struct Vertlist *)
	    calloc((size_t)1,sizeof(struct Vertlist));
          num=pK_ptr[w].num;
          vtrace->v=pK_ptr[w].flower[(nghb(p,w,v)+num-3) % num];
          v=w;
          w=vtrace->v;
      }
/* left turn */
     *v3=w;
     vtrace=vtrace->next=(struct Vertlist *)
	calloc((size_t)1,sizeof(struct Vertlist));
     num=pK_ptr[w].num;
     vtrace->v=pK_ptr[w].flower[(nghb(p,w,v)+num-2) % num];
     v=w;
     w=vtrace->v;
/* third edge */
     for (i=2;i<=n;i++) 
      {
          vtrace=vtrace->next=(struct Vertlist *)
	    calloc((size_t)1,sizeof(struct Vertlist));
          num=pK_ptr[w].num;
          vtrace->v=pK_ptr[w].flower[(nghb(p,w,v)+num-3) % num];
          v=w;
          w=vtrace->v;
      }
/* sharp left turn */
     *v4=w;
     vtrace=vtrace->next=(struct Vertlist *)
       calloc((size_t)1,sizeof(struct Vertlist));
     num=pK_ptr[w].num;
     vtrace->v=pK_ptr[w].flower[(nghb(p,w,v)+num-1) % num];
     v=w;
     w=vtrace->v;
     for (i=2;i<=n;i++) /* last edge */
      {
          vtrace=vtrace->next=(struct Vertlist *)
	    calloc((size_t)1,sizeof(struct Vertlist));
          num=pK_ptr[w].num;
          vtrace->v=pK_ptr[w].flower[(nghb(p,w,v)+num-3) % num];
          v=w;
          w=vtrace->v;
      }
     edgelist=node_to_edge(p,vertlist);
     vert_free(&vertlist);
     facelist=path_follow(p,edgelist,1);
     edge_free(&edgelist);
     return facelist;
} /* try_hex_pg */

