#include "sa_types.h"
#include "sa_proto.h"

/* Write SELECT_RADII or SELECT_CENTERS formated data to file. 
flag=1 radii, flag=2 centers. */

int write_select_r_c(struct p_data *p,char *filename,
		       char *datastr,int flag)
{
  int hits,digits=1;
  struct Vertlist *vertlist=NULL,*trace;
  char *nextpoint,*endptr;
  FILE *fp;

  nextpoint=datastr;
  stripsp(nextpoint);
  if (!(fp=fopen(filename,"a"))
      || !(vertlist=Node_link_parse(p,nextpoint,&endptr,&hits,
	   &Vlist,&Elist,&Flist,&region,pathlist,pathlength)))
    return 0;
  while ((pow(10.,(double)digits))*toler < 0.1 
	     && digits<MAX_ACCUR) digits++;  
  if (flag==2) {  /* select centers */
    fprintf(fp,"\nSELECT_CENTERS: %d \n",hits);
    trace=vertlist;
    hits=0;
    while (trace) {
      fprintf(fp," %d    ",trace->v);
      CPputd(fp,p->packR_ptr[trace->v].center.re,digits,'e');
      fprintf(fp,"  ");
      CPputd(fp,p->packR_ptr[trace->v].center.im,digits,'e');
      fprintf(fp,"\n");
      trace=trace->next;
      hits++;
    }
  }
  else {  /* select radii */
    fprintf(fp,"\nSELECT_RADII: %d \n",hits);
    trace=vertlist;
    hits=0;
    while (trace) {
      fprintf(fp," %d    ",trace->v);
      CPputd(fp,p->packR_ptr[trace->v].rad,digits,'e');
      fprintf(fp,"\n");
      trace=trace->next;
      hits++;
    }
  }
  fprintf(fp,"\n   (done)\n\nEND\n");
  fclose(fp);
  vert_free(&vertlist);
  return hits;
} /* write_vert_list */
